import App
import nt
import MissionLib
import string
import Foundation
import Lib.LibEngineering

MODINFO = {     "Author": "\"Defiant\" erik@bckobayashimaru.de",
                "Version": "0.1",
                "License": "BSD",
                "needBridge": 0
            }


CONSTRUCT_CONF_DIR = "scripts/Custom/QBautostart/conf/Construct/"
dPlugins = {}


def LoadPluginDir():
	global g_dPlugins
	
	g_dPlugins = {}
	list = nt.listdir(CONSTRUCT_CONF_DIR)

        for plugin in list:
                s = string.split(plugin, '.')
                sExtension = s[-1]
                sPluginName = string.join(s[:-1], '.')

		if sPluginName != "__init__" and sExtension == "py":
			sPluginModule = "BCROOT." + string.replace(CONSTRUCT_CONF_DIR, '/', '.') + sPluginName
			sPluginModule = string.replace(sPluginModule, "BCROOT.scripts.", "")
			
			mod = __import__(sPluginModule)
			sShip = mod.CONSTRUCT_SHIP
			g_dPlugins[sShip] = mod


def StartConstruction(sShipType, pShip):
	mod = g_dPlugins[sShipType]
	mod.StartConstruction(pShip)
	

def NewShip(pObject, pEvent):
	pShip = App.ShipClass_Cast(pEvent.GetDestination())
	
	if pShip:
		sShipType = pShip.GetScript()
		if sShipType and g_dPlugins.has_key(sShipType):
			StartConstruction(sShipType, pShip)
		
	pObject.CallNextHandler(pEvent)	


def init():
        if App.g_kUtopiaModule.IsMultiplayer():
                return
        if not Lib.LibEngineering.CheckActiveMutator("Construct Mod"):
                return

	LoadPluginDir()

	pMission = MissionLib.GetMission()
	App.g_kEventManager.AddBroadcastPythonFuncHandler(Foundation.TriggerDef.ET_FND_CREATE_SHIP, pMission, __name__ + ".NewShip")
